Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.scheduling.backportconcurrent
Class ScheduledExecutorFactoryBean

    java.lang.Object
      org.springframework.scheduling.backportconcurrent.ScheduledExecutorFactoryBean

All Implemented Interfaces:
  BeanNameAware, DisposableBean, FactoryBean, InitializingBean

    public class ScheduledExecutorFactoryBean

extends Object
implements FactoryBean, BeanNameAware, InitializingBean, DisposableBean

`FactoryBean` that sets up a JSR-166 backport `ScheduledExecutorService` (by default: `ScheduledThreadPoolExecutor` as implementation) and exposes it for bean references.

Allows for registration of `ScheduledExecutorTasks`, automatically starting the `ScheduledExecutorService` on initialization and cancelling it on destruction of the context. In scenarios that just require static registration of tasks at startup, there is no need to access the `ScheduledExecutorService` instance itself in application code.

Note that `ScheduledExecutorService` uses a `Runnable` instance that is shared between repeated executions, in contrast to Quartz which instantiates a new Job for each execution.

WARNING: `Runnables` submitted via a native `ScheduledExecutorService` are removed from the execution schedule once they throw an exception. If you would prefer to continue execution after such an exception, switch this FactoryBean's `"continueScheduledExecutionAfterException"` property to "true".

This class is analogous to the `TimerFactoryBean` class for the JDK `Timer` facility.

Since:
  2.0.3
Author:
  Juergen Hoeller
See Also:
  `ScheduledExecutorTask`, `ScheduledExecutorService`, `ScheduledThreadPoolExecutor`, `TimerFactoryBean`

Field Summary
`protected Log` | `logger`

Constructor Summary
`ScheduledExecutorFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`protected edu.emory.mathcs.backport.java.util.concurrent.ScheduledExecutorService` | `createExecutor(int poolSize, edu.emory.mathcs.backport.java.util.concurrent.ThreadFactory threadFactory, edu.emory.mathcs.backport.java.util.concurrent.RejectedExecutionHandler rejectedExecutionHandler)` Create a new `ScheduledExecutorService` instance.
`void` | `destroy()` Cancel the ScheduledExecutorService on bean factory shutdown, stopping all scheduled tasks.
`Object` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`protected Runnable` | `getRunnableToSchedule(ScheduledExecutorTask task)` Determine the actual Runnable to schedule for the given task.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton?
`protected void` | `registerTasks(ScheduledExecutorTask[] tasks, edu.emory.mathcs.backport.java.util.concurrent.ScheduledExecutorService executor)` Register the specified `ScheduledExecutorTasks` on the given `ScheduledExecutorService`.
`void` | `setBeanName(String name)` Set the name of the bean in the bean factory that created this bean.
`void` | `setContinueScheduledExecutionAfterException(boolean continueScheduledExecutionAfterException)` Specify whether to continue the execution of a scheduled task after it threw an exception.
`void` | `setExposeUnconfigurableExecutor(boolean exposeUnconfigurableExecutor)` Specify whether this FactoryBean should expose an unconfigurable decorator for the created executor.
`void` | `setPoolSize(int poolSize)` Set the ScheduledExecutorService's pool size.
`void` | `setRejectedExecutionHandler(edu.emory.mathcs.backport.java.util.concurrent.RejectedExecutionHandler rejectedExecutionHandler)` Set the RejectedExecutionHandler to use for the ThreadPoolExecutor.
`void` | `setScheduledExecutorTasks(ScheduledExecutorTask[] scheduledExecutorTasks)` Register a list of ScheduledExecutorTask objects with the ScheduledExecutorService that this FactoryBean creates.
`void` | `setThreadFactory(edu.emory.mathcs.backport.java.util.concurrent.ThreadFactory threadFactory)` Set the ThreadFactory to use for the ThreadPoolExecutor's thread pool.
`void` | `setWaitForTasksToCompleteOnShutdown(boolean waitForJobsToCompleteOnShutdown)` Set whether to wait for scheduled tasks to complete on shutdown.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    protected final Log logger

Constructor Detail

### ScheduledExecutorFactoryBean

    public ScheduledExecutorFactoryBean()

Method Detail

### setPoolSize

    public void setPoolSize(int poolSize)

  Set the ScheduledExecutorService's pool size. Default is 1.

### setThreadFactory

    public void setThreadFactory(edu.emory.mathcs.backport.java.util.concurrent.ThreadFactory threadFactory)

  Set the ThreadFactory to use for the ThreadPoolExecutor's thread pool. Default is the ThreadPoolExecutor's default thread factory.

  See Also:
    `Executors.defaultThreadFactory()`

### setRejectedExecutionHandler

    public void setRejectedExecutionHandler(edu.emory.mathcs.backport.java.util.concurrent.RejectedExecutionHandler rejectedExecutionHandler)

  Set the RejectedExecutionHandler to use for the ThreadPoolExecutor. Default is the ThreadPoolExecutor's default abort policy.

  See Also:
    `ThreadPoolExecutor.AbortPolicy`

### setExposeUnconfigurableExecutor

    public void setExposeUnconfigurableExecutor(boolean exposeUnconfigurableExecutor)

  Specify whether this FactoryBean should expose an unconfigurable decorator for the created executor.

  Default is "false", exposing the raw executor as bean reference. Switch this flag to "true" to strictly prevent clients from modifying the executor's configuration.

  See Also:
    `Executors.unconfigurableScheduledExecutorService(edu.emory.mathcs.backport.java.util.concurrent.ScheduledExecutorService)`

### setScheduledExecutorTasks

    public void setScheduledExecutorTasks(ScheduledExecutorTask[] scheduledExecutorTasks)

  Register a list of ScheduledExecutorTask objects with the ScheduledExecutorService that this FactoryBean creates. Depending on each ScheduledExecutorTask's settings, it will be registered via one of ScheduledExecutorService's schedule methods.

  See Also:
    `ScheduledExecutorService.schedule(java.lang.Runnable, long, edu.emory.mathcs.backport.java.util.concurrent.TimeUnit)`, `ScheduledExecutorService.scheduleWithFixedDelay(java.lang.Runnable, long, long, edu.emory.mathcs.backport.java.util.concurrent.TimeUnit)`, `ScheduledExecutorService.scheduleAtFixedRate(java.lang.Runnable, long, long, edu.emory.mathcs.backport.java.util.concurrent.TimeUnit)`

### setContinueScheduledExecutionAfterException

    public void setContinueScheduledExecutionAfterException(boolean continueScheduledExecutionAfterException)

  Specify whether to continue the execution of a scheduled task after it threw an exception.

  Default is "false", matching the native behavior of a `ScheduledExecutorService`. Switch this flag to "true" for exception-proof execution of each task, continuing scheduled execution as in the case of successful execution.

  See Also:
    `ScheduledExecutorService.scheduleAtFixedRate(java.lang.Runnable, long, long, edu.emory.mathcs.backport.java.util.concurrent.TimeUnit)`

### setWaitForTasksToCompleteOnShutdown

    public void setWaitForTasksToCompleteOnShutdown(boolean waitForJobsToCompleteOnShutdown)

  Set whether to wait for scheduled tasks to complete on shutdown.

  Default is "false". Switch this to "true" if you prefer fully completed tasks at the expense of a longer shutdown phase.

  See Also:
    `ExecutorService.shutdown()`, `ExecutorService.shutdownNow()`

### setBeanName

    public void setBeanName(String name)

  Description copied from interface: `BeanNameAware`
  Set the name of the bean in the bean factory that created this bean.

  Invoked after population of normal bean properties but before an init callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

  Specified by:
    `setBeanName` in interface `BeanNameAware`
  Parameters:
    `name` - the name of the bean in the factory. Note that this name is the actual bean name used in the factory, which may differ from the originally specified name: in particular for inner bean names, the actual bean name might have been made unique through appending "#..." suffixes. Use the `BeanFactoryUtils.originalBeanName(String)` method to extract the original bean name (without suffix), if desired.

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### createExecutor

    protected edu.emory.mathcs.backport.java.util.concurrent.ScheduledExecutorService createExecutor(int poolSize,
                                                                                                     edu.emory.mathcs.backport.java.util.concurrent.ThreadFactory threadFactory,
                                                                                                     edu.emory.mathcs.backport.java.util.concurrent.RejectedExecutionHandler rejectedExecutionHandler)

  Create a new `ScheduledExecutorService` instance. Called by `afterPropertiesSet`.

  The default implementation creates a `ScheduledThreadPoolExecutor`. Can be overridden in subclasses to provide custom `ScheduledExecutorService` instances.

  Parameters:
    `poolSize` - the specified pool size
    `threadFactory` - the ThreadFactory to use
    `rejectedExecutionHandler` - the RejectedExecutionHandler to use
  Returns:
    a new ScheduledExecutorService instance
  See Also:
    `afterPropertiesSet()`, `ScheduledThreadPoolExecutor`

### registerTasks

    protected void registerTasks(ScheduledExecutorTask[] tasks,
                                 edu.emory.mathcs.backport.java.util.concurrent.ScheduledExecutorService executor)

  Register the specified `ScheduledExecutorTasks` on the given `ScheduledExecutorService`.

  Parameters:
    `tasks` - the specified ScheduledExecutorTasks (never empty)
    `executor` - the ScheduledExecutorService to register the tasks on.

### getRunnableToSchedule

    protected Runnable getRunnableToSchedule(ScheduledExecutorTask task)

  Determine the actual Runnable to schedule for the given task.

  Wraps the task's Runnable in a `DelegatingExceptionProofRunnable` if necessary, according to the `"continueScheduledExecutionAfterException"` flag.

  Parameters:
    `task` - the ScheduledExecutorTask to schedule
  Returns:
    the actual Runnable to schedule (may be a decorator)

### getObject

    public Object getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### destroy

    public void destroy()

  Cancel the ScheduledExecutorService on bean factory shutdown, stopping all scheduled tasks.

  Specified by:
    `destroy` in interface `DisposableBean`
  See Also:
    `ExecutorService.shutdown()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.